﻿@using System.Text.Json;
@using Microsoft.AspNetCore.SignalR.Client
@using BlazorChatTest.Shared.Domain
@using Markdig;
@using System.IO
@using System.Net.Http;
@using Newtonsoft.Json; 

@inject NavigationManager NavigationManager
@inject BlazorChatTest.Shared.Services.IChatService ChatService
@inject IJSRuntime JSRuntime;

@using Tewr.Blazor.FileReader;
@inject IFileReaderService fileReader
@inject IHttpClientFactory ClientFactory

<style>
    .resizedImg {
        height: 200px;
        background-color: #ccc;
        border-style: solid;
        border-width: 1px;
        border-color: #ccc;
        /* border-radius */
        -webkit-border-radius: 5px;
        -moz-border-radius: 5px;
        border-radius: 5px;
        /* box-shadow */
        -webkit-box-shadow: rgba(0,0,0,0.8) 0px 0 3px;
        -moz-box-shadow: rgba(0,0,0,0.8) 0 0 3px;
        box-shadow: rgba(0,0,0,0.8) 0 0 3px;
        cursor: pointer;
        transition: opacity 1s;
    }

        .resizedImg:hover {
            opacity: 0.5;
        }
</style>

<div class="card" style="margin:15px;">
    <div class="card-header">
        <h5>Live-Chat</h5>
        <h6 class="card-subtitle mb-2 text-muted">
            <AuthorizeView>
                <Authorized>You are logged in</Authorized>
                <NotAuthorized>Log in to access all features</NotAuthorized>
            </AuthorizeView>
        </h6>
    </div>

    <ul id="messagesList" class="list-group list-group-flush">
        @if (AllMessages != null)
        {
@foreach (var UserMessage in AllMessages)
{
<li class="list-group-item" style="@(UserMessage.User.Equals(ChatSystemMsg.SystemUser) ? "color: #ccc;font-style:italic;font-weight:bold;" : "")">
    <strong>@UserMessage.User.EMail</strong> <sup>@UserMessage.GetTimeDifference()</sup>
    @if (UserMessage.User.IsGuest)
    {
<span class="badge badge-pill badge-dark">Guest</span>}
    <div style="font-size:small;">
        @foreach (var Submsg in UserMessage.Messages)
        {
<div class="animated lightSpeedIn">@((MarkupString)Markdown.ToHtml(Submsg))</div>}
    </div>
</li>
}}
    </ul>
    <div class="card-body">
        <EditForm Model="@ChatService.ChatForm" Context="formContext">
            <DataAnnotationsValidator />
            <AuthorizeView>
                <NotAuthorized>
                    <div class="input-group mb-3 @(ChatService.HasSentMsg ? "animated fadeOut":"")">
                        <div class="input-group-prepend">
                            <span class="input-group-text" id="addon-mail">&#x00040;</span>
                        </div>
                        <input type="text" class="form-control" placeholder="E-Mail" aria-label="E-Mail" aria-describedby="addon-inputmail" @bind-value="ChatService.ChatForm.CurrentUser.EMail" />
                    </div>
                    <ValidationMessage For="@(() => ChatService.ChatForm.CurrentUser.EMail)" />
                </NotAuthorized>
            </AuthorizeView>

            <small style="font-style:italic;font-weight: bold;">Markdown and Html are supported :-)</small>

            <input type="text" placeholder="Message..." id="emojiable" />

            <button type="submit" @onclick="HandleSubmit">send</button>

            <p>@_MessageValidation</p>

        </EditForm>
        <input type="file" @ref="inputReference" @onchange="async () => await UploadFileAsync()" />

    </div>
    <div style="color:red;">@errorMessage</div>
</div>


@code { ElementReference inputReference;
    string message = string.Empty;
    string imagePath = null;
    string test = "";
    string fileName = string.Empty;
    string type = string.Empty;
    string size = string.Empty;
    string errorMessage = "";

    Stream fileStream = null;

    List<BlazorChatTest.Shared.Domain.ChatElements.ChatElement> AllMessages = null;

    async Task UploadFileAsync()
    {
        // Read the files
        var file = (await fileReader.CreateReference(inputReference).EnumerateFilesAsync()).FirstOrDefault();
        if (file == null)
            return;

        // Get the info of that files
        var fileInfo = await file.ReadFileInfoAsync();
        fileName = fileInfo.Name;
        size = $"{fileInfo.Size}b";
        type = fileInfo.Type;
        using (var ms = await file.CreateMemoryStreamAsync((int)fileInfo.Size))
        {
            fileStream = new MemoryStream(ms.ToArray());
        }
        // Create the content
        var content = new MultipartFormDataContent();
        content.Headers.ContentDisposition = new System.Net.Http.Headers.ContentDispositionHeaderValue("form-data");

        content.Add(new StreamContent(fileStream, (int)fileStream.Length), "image", fileName);


        string url = "https://localhost:44390";
        test = $"{url}/{BlazorChatTest.Shared.ICommonRoutes.FILE_UPLOAD}";

        try
        {
            var client = ClientFactory.CreateClient("ServerAPI");

            var response = await client.PostAsync($"{url}/api/file", content);


            test = "asd";
            if (response.IsSuccessStatusCode)
            {
                var uploadedFileName = await response.Content.ReadAsStringAsync();
                imagePath = $"{url}/{uploadedFileName}";
                AddFiles(new List<string>() { imagePath });
            }
        }
        catch (Microsoft.AspNetCore.Components.WebAssembly.Authentication.AccessTokenNotAvailableException exception)
        {
            exception.Redirect();
        }
    }
    [CascadingParameter] Task<AuthenticationState> AuthenticationStateTask { get; set; }

    private List<string> CustomSymbols = new List<string>()
{
        "⺀", "⽥", "⽨", "⽣", "㣕"
    };
    private string _MessageValidation = "";

    private async void HandleSubmit()
    {
        _MessageValidation = "";
        ChatService.ChatForm.MessageInput = await JSRuntime.InvokeAsync<string>("readEmojiText");
        await JSRuntime.InvokeAsync<string>("readEmojiClearText");
        if (ChatService.ChatForm.MessageInput != null && ChatService.ChatForm.MessageInput.Trim() != "")
        {
            try
            {

                await ChatService.Send();
                errorMessage = "";
            }
            catch(InvalidOperationException ex) {
                errorMessage = "you are in offline mode!";
            }
            StateHasChanged();

        }
        else
        {
            _MessageValidation = "Nothing to say?";
        }
    }

    private void AddToMsg(string msg) => ChatService.ChatForm.MessageInput += msg;

    public void AddFiles(List<string> imgUris)
    {
        foreach (string imgUri in imgUris) AddToMsg($"<img src='{imgUri}' alt='Image' class='resizedImg' />");

        ChatService.Send();
        StateHasChanged();
    }

    protected override async Task OnInitializedAsync()
    {


        ChatService.HubConnection = new HubConnectionBuilder()
        .WithUrl(NavigationManager.ToAbsoluteUri(BlazorChatTest.Shared.ICommonRoutes.CHAT_HUB))
        .Build();


        ChatService.HubConnection.On<string, MsgPriority>(BlazorChatTest.Shared.Hubs.HubEvent.IPublic.SYSTEM_MSG, async (message, priority) =>
        {
            var lastMessage = ChatService.AllMessages.LastOrDefault();
            if (lastMessage != null && lastMessage.User.Equals(ChatSystemMsg.SystemUser))
            {
                lastMessage.Messages.Add(message);
            }
            else
            {
                ChatService.AllMessages.Add(new ChatSystemMsg(new List<string> { message }, priority));
            }
            AllMessages.Add(ChatService.AllMessages.LastOrDefault());
        });

        ChatService.HubConnection.On<string, string>(BlazorChatTest.Shared.Hubs.HubEvent.IPublic.RECEIVE_MSG, async (user, message) =>
        {
            var chatUser = JsonConvert.DeserializeObject<ChatUser>(user);
            var allMessages = ChatService.AllMessages;
            var lastMessage = allMessages.LastOrDefault();
            if (lastMessage != null && lastMessage.User.Equals(chatUser))
            {
                // If last message has been written by the same user, add it to the last chatMsg-obj
                lastMessage.Messages.Add(message);
            }
            else
            {
                // other user typed msg
                ChatService.AllMessages.Add(
                                                                 new ChatMsg(chatUser, new List<string> { message })
                                                             );
            }
            if (!String.IsNullOrEmpty(AllMessages.LastOrDefault().User.EMail) && AllMessages.LastOrDefault().User.EMail == ChatService.AllMessages.LastOrDefault().User.EMail)
            {
                AllMessages.LastOrDefault().Messages.Add(ChatService.AllMessages.LastOrDefault().Messages.LastOrDefault());
            }
            else
            {
                AllMessages.Add(ChatService.AllMessages.LastOrDefault());
            }

            await JSRuntime.InvokeAsync<object>("setMessageInLocalStorage", JsonConvert.SerializeObject(AllMessages));

            StateHasChanged();
        });

        try
        {
            LoadSavedDataInOfflineMode();

            await ChatService.HubConnection.StartAsync();
            await SetUsernameIfLoggedIn();
            await ChatService.Join(); // notify other chat members about new chatter
        }
        catch(Exception ex)
        {
            await JSRuntime.InvokeAsync<string>("setText", ex.Message);
        }
        await JSRuntime.InvokeAsync<object>("InitPage");

    }

    public async void LoadSavedDataInOfflineMode() {
        var serializedSavedList = await JSRuntime.InvokeAsync<string>("getMessageInLocalStorage");
        if (!String.IsNullOrEmpty(serializedSavedList.Trim()))
        {
            AllMessages = JsonConvert.DeserializeObject<List<BlazorChatTest.Shared.Domain.ChatElements.ChatElement>>(serializedSavedList);
        }
        StateHasChanged();
    }

    public async Task SetUsernameIfLoggedIn()
    {
        var authState = await AuthenticationStateTask;
        var user = authState.User;
        if (user.Identity.IsAuthenticated)
        {
            ChatService.ChatForm.CurrentUser.EMail = user.Identity.Name;
        }
        ChatService.ChatForm.CurrentUser.IsGuest = !user.Identity.IsAuthenticated;
    } }


